#include "stdafx.h"

class BD {
public:
  struct Better {
    bool operator()(BD* l, BD* r);
  };

  enum {
    YET = 0, DEAD, ABORT, GOAL
  };

  explicit BD(FILE* fp);
  BD(const BD&) = default;

  void show(FILE* o = stderr) const;

  void tick(char c);

  int num_lambda() const { return num_lambda_; }
  int lambda() const { return lambda_; }
  int getLeftLambda() const { return num_lambda_ - lambda_; }
  int score() const { return score_; }
  int getFinishScore() const {
    if (done_)
      return score_;
    else
      return score_ + total_lambda_ * 25;
  }
  bool done() const { return done_; }
  bool dead() const { return done_ == DEAD; }
  int state() const { return done_; }
  bool goal() const { return done_ == GOAL; }
  const string& seq() const { return seq_; }
  const vector<string> mine() const { return mine_; }
  int x() const { return x_; }
  int y() const { return y_; }
  int w() const { return w_; }
  int w(int y) const { return (int)mine_[y].size(); }
  int h() const { return h_; }

  char get(int x, int y) const {
    return mine_[y][x];
  }
  char safeGet(int x, int y) const {
    if (x < 0 || y < 0 ||
        y >= (int)mine_.size() || x >= (int)mine_[y].size())
      return '#';
    return mine_[y][x];
  }

  void reset() {
    //score_ = 0;
    lambda_ = 0;
    seq_.clear();
    calcNumLambda();
  }

  void calcNumLambda();

  bool getGoal(int* x, int* y) const;
  bool makeGoal(int* x, int* y);

  int getWaterLevel() const {
    return flooding_ ? water_ + turn_ / flooding_ : 0;
  }

  int life() const { return life_; }

  int getDistance(int gx, int gy) const;

private:
  void addScore(int score);
  void move(int dx, int dy, int* rx);

  vector<string> mine_;
  vector<pair<int, int> > rocks_;
  int num_lambda_;
  int lambda_;
  int total_lambda_;
  int score_;
  int done_;
  int x_, y_;
  int w_, h_;
  string seq_;
  int turn_;
  int water_;
  int flooding_;
  int waterproof_;
  int life_;
  int gx_, gy_;
};
