#include "bd.h"

#include <ctype.h>

int main(int argc, char* argv[]) {
  if (argc < 2) {
    fprintf(stderr, "%s <map> [ctrl]\n", argv[0]);
    abort();
  }

  FILE* ctrl_fp = stdin;
  if (argc == 3) {
    ctrl_fp = fopen(argv[2], "rb");
    assert(ctrl_fp);
  }

  FILE* map_fp = fopen(argv[1], "rb");
  assert(map_fp);

  BD bd(map_fp);
  fclose(map_fp);

  for (int turn = 0; !bd.done(); turn++) {
    printf("=== turn %d score=%d water=%d life=%d ===\n",
           turn, bd.score(), bd.getWaterLevel() - 1, bd.life());
    bd.show(stdout);
    puts("");

    int c = EOF;
    for (;;) {
      c = fgetc(ctrl_fp);
      if (!isspace(c))
        break;
    }
    if (c == EOF) {
      puts("EOF");
      break;
    }

    bd.tick(c);
  }

  bd.show(stdout);

  printf("seq=%s\n", bd.seq().c_str());
  printf("score=%d\n", bd.score());
}
